'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _cuid = require('cuid');

var _cuid2 = _interopRequireDefault(_cuid);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by timur on 2/20/17.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown() {
    _classCallCheck(this, Dropdown);

    return _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).apply(this, arguments));
  }

  _createClass(Dropdown, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          dropup = _props.dropup,
          children = _props.children,
          title = _props.title,
          right = _props.right,
          group = _props.group,
          className = _props.className;

      var id = (0, _cuid2.default)();
      var items = [].concat(children);
      var dropdownItems = items.map(function (item, i) {
        var _item$props = item.props,
            to = _item$props.to,
            href = _item$props.href,
            disabled = _item$props.disabled;


        switch (item.type) {
          case 'hr':
            return _react2.default.createElement('li', {
              key: i,
              role: 'separator',
              className: 'divider'
            });

          case 'header':
            return _react2.default.createElement(
              'li',
              {
                key: i,
                className: 'dropdown-header'
              },
              item
            );
        }

        if (disabled) {
          return _react2.default.createElement(
            'li',
            {
              key: i,
              className: 'disabled'
            },
            _react2.default.createElement(
              'a',
              null,
              item
            )
          );
        }

        if (to) {
          return _react2.default.createElement(
            'li',
            { key: i },
            _react2.default.createElement(_reactRouter.Link, {
              to: to,
              children: item
            })
          );
        }

        return _react2.default.createElement(
          'li',
          { key: i },
          _react2.default.createElement(
            'a',
            { href: href ? href : '#' },
            item
          )
        );
      });

      var dropdownLink = _react2.default.createElement(
        'a',
        {
          id: id,
          className: 'btn btn-default dropdown-toggle' + (right ? ' pull-right' : ''),
          type: 'button',
          'data-toggle': 'dropdown',
          'aria-haspopup': 'true',
          'aria-expanded': 'true'
        },
        title,
        ' ',
        _react2.default.createElement('span', { className: 'caret' })
      );

      var dropdownMenu = _react2.default.createElement(
        'ul',
        {
          className: 'dropdown-menu' + (right ? ' dropdown-menu-right' : ''),
          'aria-labelledby': id
        },
        dropdownItems
      );

      return group ? _react2.default.createElement(
        'div',
        { className: className },
        dropdownLink,
        dropdownMenu
      ) : _react2.default.createElement(
        'div',
        { className: dropup ? 'dropup' : 'dropdown' },
        dropdownLink,
        dropdownMenu
      );
    }
  }]);

  return Dropdown;
}(_react2.default.Component);

Dropdown.propTypes = {
  children: _react2.default.PropTypes.any.isRequired
};

exports.default = Dropdown;